#ifndef AUDIO_H
#define AUDIO_H

#include <QTabWidget>
#include <QProcess>
namespace Ui {
class Audio;
}

class Audio : public QTabWidget
{
    Q_OBJECT

public:
    explicit Audio(QWidget *parent = 0);
    ~Audio();
private slots:
  // Amarok //////////////////
void on_abackButton_clicked();
void on_anextButton_clicked();
void on_aplayButton_clicked();
void on_apauseButton_clicked();
// Banshee ///////////////////
void on_bbackButton_clicked();
void on_bnextButton_clicked();
void on_bplayButton_clicked();
void on_bpauseButton_clicked();
//rhythmbox///////////////////
void on_rbackButton_clicked();
void on_rnextButton_clicked();
void on_rplayButton_clicked();
void on_rpauseButton_clicked();
// run exit///////////////////

// amarok tap
void on_arunButton_clicked();
void on_exitButton_clicked();

// Banshee tap
void on_runbButton_clicked();
void on_exit2Button_clicked();

// rhythmbox tap
void on_runrButton_clicked();
void on_exit3Button_clicked();


private:


private:
    Ui::Audio *ui;

    QProcess *proc;};

#endif // AUDIO_H
