// Powert by leon jacobs
/////////////////////////////////////////////////////////////////////////
// add some buttons for facebook                                       //
//                                                                     //
//  Fb4linuxmedia dialog is facebook blue now                          //
//                                                                     //
//  Fb4linuxmeia dialog exit auto if you Click a button               //
//                                                                     //
//  add a cancel button on  fb4linuxmedia dialog                       //
//                                                                     //
// add a welcome notification                                          //
//                                                                     //
// add buttons to go to Google+ twitter and for soures Facebook        //
// removet on the top left and right the two web view                  //
//                                                                     //
/////////////////////////////////////////////////////////////////////////


/////////////////////////////////////////////////////////////////////////
// how to compile                                                      //
// ''''''''''''''                                                      //
// open a terminal and go to fb4linux??? folder                        //
// tipe in the terminal qmake & make or compile on qt creator          //
// if compile complete run or tipe fb4linux                            //
// fb4linux and the audio control have to be in the /usr/bin folder    //
// Example for ubuntu                                                  //
// open a terminal : tipe sudo nautilus                                //
// copy the binary and past in the  /usr/bin folder                    //
// i hope you like facebook for linux                                 //
/////////////////////////////////////////////////////////////////////////

#include "FacebookWidget.h"
#include "ui_FacebookWidget.h"
#include <QWebFrame>
#include <QDebug>
#include <QTimer>
#include <QVariant>
#include <QWebSettings>
#include <QDir>
#include <QNetworkAccessManager>
#include <QDesktopServices>
#include <QDesktopWidget>
#include <QProcess>


FacebookWidget::FacebookWidget(QWidget *parent) :
    QWidget(parent),
    ui(new Ui::FacebookWidget)
{
    systemTrayIcon = new QSystemTrayIcon(QIcon(":/res/logo/Facebook-icon.png"));
    systemTrayMenu = new QMenu();
    googleAction = new QAction(tr("Go to Google+"),this);
    likeAction = new QAction(tr("Like Facebook for linux on facebook"),this);
    supportAction = new QAction(tr("send me an email for help"),this);
    facebookAction = new QAction(tr("Go to Facebook"),this);
    twitterAction = new QAction(tr("Go to Twitter"),this);
    spendAction = new QAction(tr("Donate"),this);
    quitAction = new QAction(tr("Quit"),this);
    windowVisibilityToggleAction = new QAction(tr("Hide"),this);
    aboutWindow = new AboutWindow();
    audio = new Audio();




    windowVisible = true;
    systemTrayMenu->addAction(windowVisibilityToggleAction);
    systemTrayMenu->addSeparator();
    systemTrayMenu->addAction(facebookAction);
    systemTrayMenu->addSeparator();

    systemTrayMenu->addAction(twitterAction);
    systemTrayMenu->addSeparator();

    systemTrayMenu->addAction(googleAction);
    systemTrayMenu->addSeparator();

    systemTrayMenu->addAction(likeAction);
    systemTrayMenu->addSeparator();

    systemTrayMenu->addAction(supportAction);
    systemTrayMenu->addSeparator();

    systemTrayMenu->addAction(spendAction);
    systemTrayMenu->addSeparator();

    systemTrayMenu->addAction(quitAction);
    systemTrayIcon->setContextMenu(systemTrayMenu);
    systemTrayIcon->show();
    pressed = false;
    ui->setupUi(this);

      webView = new QWebView();
    ui->mainLayout->addWidget(webView);
    webView->page()->setLinkDelegationPolicy(QWebPage::DelegateAllLinks);
    this->setLayout(ui->mainLayout);
    webView->setUrl(QUrl("https://iphone.facebook.com"));






           connect(webView,SIGNAL(loadProgress(int)),ui->progressBar,SLOT(setValue(int)));
    connect(webView,SIGNAL(loadFinished(bool)),ui->progressBar,SLOT(reset()));
    connect(ui->backButton,SIGNAL(clicked()),webView,SLOT(back()));
    connect(ui->forwardButton,SIGNAL(clicked()),webView,SLOT(forward()));
    connect(ui->closeButton,SIGNAL(clicked()),this,SLOT(toggleWindowVisibility()));
    connect(quitAction,SIGNAL(triggered()),this,SLOT(quitActionTriggered()));
    connect(systemTrayIcon,SIGNAL(activated(QSystemTrayIcon::ActivationReason)),this,SLOT(onSystemTrayClicked(QSystemTrayIcon::ActivationReason)));
    connect(facebookAction,SIGNAL(triggered()),this,SLOT(facebookActionTriggered()));
    connect(twitterAction,SIGNAL(triggered()),this,SLOT(twitterActionTriggered()));
    connect(googleAction,SIGNAL(triggered()),this,SLOT(googleActionTriggered()));
    connect(likeAction,SIGNAL(triggered()),this,SLOT(likeActionTriggered()));
    connect(supportAction,SIGNAL(triggered()),this,SLOT(supportActionTriggered()));
    connect(spendAction,SIGNAL(triggered()),this,SLOT(spendActionTriggered()));
connect(this, SIGNAL(linkClicked(const QUrl &)), SLOT(linkIsClicked(const QUrl&)),Qt::DirectConnection);
    connect(windowVisibilityToggleAction,SIGNAL(triggered()),this,SLOT(toggleWindowVisibility()));
        connect(ui->aboutButton,SIGNAL(clicked()),aboutWindow,SLOT(show()));
    connect(ui->audioButton,SIGNAL(clicked()),audio,SLOT(show()));

    resize( QApplication::desktop()->size() );
        setWindowFlags( Qt::FramelessWindowHint );

    QWebSettings::globalSettings()->setAttribute(QWebSettings::PluginsEnabled,true);

}

FacebookWidget::~FacebookWidget()
{
    delete ui;
}

void FacebookWidget::mousePressEvent(QMouseEvent *event)
{
    if(event->button() & Qt::LeftButton)
        pressed = true;
    else
        pressed = false;
    lastPos = event->pos();
}
void FacebookWidget::mouseMoveEvent(QMouseEvent *)
{
    if(pressed)
    {
        move(QCursor::pos() - lastPos);
    }
}





void FacebookWidget::onSystemTrayClicked(QSystemTrayIcon::ActivationReason reason) {
    if (reason == QSystemTrayIcon::Trigger) toggleWindowVisibility();
}

void FacebookWidget::twitterActionTriggered() {
    this->show();
    this->raise();
    windowVisible = true;
    windowVisibilityToggleAction->setText(tr("Hide"));

    webView->load(QUrl("https://twitter.com/"));
}

void FacebookWidget::facebookActionTriggered() {
    this->show();
    this->raise();
    windowVisible = true;
    windowVisibilityToggleAction->setText(tr("Hide"));
           webView->load(QUrl("https://iphone.facebook.com"));
}

void FacebookWidget::googleActionTriggered() {
    this->show();
    this->raise();
    windowVisible = true;
    windowVisibilityToggleAction->setText(tr("Hide"));
    webView->load(QUrl("https://plus.google.com/"));
}


void FacebookWidget::likeActionTriggered() {
        this->show();
        this->raise();
        windowVisible = true;
        windowVisibilityToggleAction->setText(tr("Hide"));
    webView->load(QUrl("http://www.facebook.com/pages/Fb_4_linux/515888741815224"));
}

void FacebookWidget::spendActionTriggered() {
        this->show();
        this->raise();
        windowVisible = true;
        windowVisibilityToggleAction->setText(tr("Hide"));
        QDesktopServices::openUrl(QUrl(tr("http://fb-4-linux.bugs3.com/thx.html")));
    }



void FacebookWidget::supportActionTriggered() {

        QDesktopServices::openUrl(QUrl(tr("mailto:leonjacobios1@gmail.com?subject=Facebook-for-linux-support")));
}
void FacebookWidget::toggleWindowVisibility() {
    if(windowVisible) {
        this->hide();
        windowVisible = false;
        windowVisibilityToggleAction->setText(tr("Show"));
    } else {
        this->show();
        this->raise();
        windowVisible = true;
        windowVisibilityToggleAction->setText(tr("Hide"));
    }
}
// Facebook control

void FacebookWidget::on_newsButton_clicked()
{
    webView->load(QUrl("https://touch.facebook.com/home.php"));
}

void FacebookWidget::on_myButton_clicked()
{
    webView->load(QUrl("https://touch.facebook.com/friends"));
}

void FacebookWidget::on_msgButton_clicked()
{
    webView->load(QUrl("https://touch.facebook.com/messages"));

}void FacebookWidget::on_chatButton_clicked()
{
    webView->load(QUrl("https://touch.facebook.com/buddylist.php"));

}
void FacebookWidget::on_eventButton_clicked()
{
    webView->load(QUrl("https://touch.facebook.com/events/"));

}


void FacebookWidget::on_likeButton_clicked()
{
   webView->load(QUrl("http://www.facebook.com/pages/Fb_4_linux/515888741815224"));

}

void FacebookWidget::on_gButton_clicked()
{
   webView->load(QUrl("https://plus.google.com"));

}
void FacebookWidget::on_fButton_clicked()
{
   webView->load(QUrl("https://touch.facebook.com"));

}
void FacebookWidget::on_tButton_clicked()
{
   webView->load(QUrl("https://twitter.com"));

}
void FacebookWidget::on_ppButton_clicked()
{
    QDesktopServices::openUrl(QUrl(tr("http://fb-4-linux.bugs3.com/thx.html")));

}
void FacebookWidget::on_webButton_clicked()
{
    QDesktopServices::openUrl(QUrl(tr("http://fb-4-linux.bugs3.com")));

}

void FacebookWidget::quitActionTriggered() {

    qApp->quit();

}










